﻿; http://www.autohotkey.com/forum/viewtopic.php?t=64464

{ ; Auto-Execute
	#NoTrayIcon
	SetBatchLines, -1
	CoordMode, Mouse, Screen
	Gui, +ToolWindow ; +AlwaysOnTop
}



{ ; Preload playback
	File = playback.smr
	if File {
		if FileExist(File) {
			FileRead, script, %File%
			if ErrorLevel
			{
				MsgBox, 16, Error, Error accessing the existing file:`n%File%
				ExitApp
			}
		}
		else
		{
			MsgBox, 262160, File Error, Cannot find file:`n%File%
			ExitApp
		}
	}
	Menu, Tray, Icon	
}

{ ; GUI
	; Detect type of running script.
	if (A_PtrSize <> 4)
	{
		MsgBox, 48, Information, Please note:`nYou are using the 64bit version of Autohotkey. It has been reported that there are some issues with using this version.`nIf you have problems using the playback, please rerun Autohotkey setup and select Unicode 32bit.`nThank you.
	}
	Gui, Add, Link,, Modified <a href="http://www.autohotkey.com/forum/viewtopic.php?t=64464">Mouse and Click recorder</a>
	Gui, Add, Text,, Please set a 
	Gui, font, bold
	Gui, Add, Text, X+0, 16:9 resolution
	Gui, font
	Gui, Add, Text, X+5, (e.g. 1280x720, 1600x900, 1920x1080).
	Gui, font, bold
	Gui, Add, Text, X+5, 4:3 won't work!
	Gui, font
	Gui, Add, Text, x10 Y+20, Start Deponia configuration
	Gui, Add, Text, x10, Switch on "fullscreen mode"
	Gui, Add, Text, Y+20, Start Deponia
	Gui, font, bold
	Gui, Add, Text, x10, Be sure you only have "Ulysses helmet" and the three datasettes in your inventory.
	Gui, font
	Gui, Add, Text, x10, Go to the zoo in Elysium.
	Gui, Add, Text, Y+30, If anything goes wrong, please remember
	Gui, font, bold s15
	Gui, Add, Text, x10, Ctrl+Shift+S
	Gui, font
	Gui, font, bold
	Gui, Add, Text, x10, This is the hotkey to stop playback!
	Gui, font
	Gui, Add, Text, Y+30, To start the playback, press Ctrl+Shift+P while in game. You will hear a few beeps for a 5s countdown.
	Gui, Add, Text,, It will take about 1:15 hour to switch through all possibilities, so sit back and enjoy.
	;Gui, Add, Button,, Play
	Gui, Add, Button,, Stop
	Gui, Show,, Mouse Recorder
	GuiControl("Stop=0,Play=0")
	;FileRead, script, %A_ScriptDir%\playback.smr
	GuiControl("Play=1")

}
{ ; Hotkeys
	^+s:: GoSub, ButtonStop
	^+p:: GoSub, ButtonPlay
	return
}	

GuiClose:
{
	ExitApp
}

; GUI Buttons
ButtonStop: ; Stop Recording
{
	if playing {
		playing := false
		msgbox Playback stopped via hotkey
		return
	}
	Gui, Show, , Mouse Recorder
	GuiControl("Record=1,Stop=0,Play=1")
	recording := false ; Stop Recording
	return
}

CheckDeponia:
{
	WinGetTitle, WindTitle, A
	if (WindTitle <> "Deponia Doomsday")
	{
		MsgBox Deponia is not the active window. Stopping playback ...
		playing := false
	}
	else
	{
		; Screen size must match witch windowsize
		WinGetPos, WindX, WindY, WindW, WindH, A
		if (WindX <> MonSizeLeft or WindY <> MonSizeTop or WindW <> MonSizeRight or WindH <> MonSizeBottom)
		{
			msgbox Deponia has to be configured as fullscreen and has to run on the first screen. Stopping playback ...
			playing := false
		}
		;msgbox %WindX%, %WindY% - %WindW%, %WindH% - %WindTitle%
	}

	return
}

ButtonPlay: ; Playback
{
	;Gui, Show, , Playing ...
	StoredX := StoredY := ""
	playing := true
	
	
	; 2048x1152 was my resolution for the generated record. It will get automatically be resized
	SysGet, MonSize, Monitor
	multX := MonSizeRight / 2048
	multY := MonSizeBottom / 1152
	aspect := MonSizeRight / MonSizeBottom
	if (aspect < 1.777 or aspect > 1.778)
	{
		msgbox Screen resolution has to be a 16:9 resolution (width/height = 1.7777777778). Stopping playback ...
		playing := false
	}
	;MsgBox, Left: %MonSizeLeft% -- Top: %MonSizeTop% -- Right: %MonSizeRight% -- Bottom %MonSizeBottom% -- %multX% %multY%.
	gosub CheckDeponia
	
	if playing
	{
		SoundBeep
		Sleep, 1000
		SoundBeep
		Sleep, 1000
		SoundBeep
		Sleep, 1000
		SoundBeep
		Sleep, 1000
		SoundBeep
		SoundBeep
		SoundBeep
		SoundBeep
	}
	;return
	
	Loop, Parse, script, .
	{
		Sleep, 100
		if Not playing
			break
		else if RegExMatch(A_LoopField,"(\d+),(\d+)",p) {
			gosub CheckDeponia
			p1 := p1 * multX
			p2 := p2 * multY
			MouseMove, %p1%, %p2%, 0
			StoredX:=p1, StoredY:=p2
		} else if (A_LoopField = "+") {
			Sleep, 1
		}
		else
		{
			gosub CheckDeponia
			Send, {%A_LoopField%}
		}
	}
	if Playing
	{
		msgbox Playback completed
	}
	playing := false
	;Gui, Show, , Mouse Recorder
	return
}

GuiControl(option) {
	Loop, Parse, option, `,
	{
		StringSplit, item, A_LoopField, =
		GuiControl, % (item2 ? "En":"Dis") "able", %item1%
	}
}
